#!/bin/bash
#
# EeePC VGA toggle
# Andrew Wyatt
# Tool to enable / disable VGA output

. /etc/default/eeepc-acpi
if [ -e "/etc/default/eeepc-acpi.local" ]; then
  . /etc/default/eeepc-acpi.local
fi

if [ -e "$EEEPC_VAR/hardware" ]; then
. $EEEPC_VAR/hardware
fi

. /etc/acpi/eeepc/eeepc-notify.sh

NICON="display"

if [ ! -d "$EEEPC_VAR" ]; then
  mkdir $EEEPC_VAR 2>/dev/null
fi

LVDS_DEVICE=$(xrandr | grep " connected" | awk '{print $1}' | grep LVDS)
LVDS_XRANDR=$(xrandr)
LVDS_STATUS=$(cat $EEEPC_VAR/lvds-state 2>/dev/null)
LVDS_CURRENT=$(echo $LVDS_CURRENT | grep -F -e $LVDS_DEVICE -A 12 | grep -F -e [0-9]x[0-9] -e "*" | awk '{print $1}')

if [ "$LVDS_STATUS" = "0" ]; then
  if [ -e "$EEEPC_VAR/lvds-resolution" ]; then
    LVDS_RESTORE=$(cat $EEEPC_VAR/lvds-resolution)
    rm -f $EEEPC_VAR/lvds-resolution
  fi
  echo 1 > $EEEPC_VAR/lvds-state
  if [[ "$LVDS_RESTORE" =~ [0-9] ]]; then
    su $EEE_USER -l -c "DISPLAY=:0 xrandr --output $LVDS_DEVICE --mode $LVDS_RESTORE"
  else
    su $EEE_USER -l -c "DISPLAY=:0 xrandr --output $LVDS_DEVICE --auto"
  fi
  eeepc_notify "Display Enabled" $NICON
else
  echo $LVDS_CURRENT > $EEEPC_VAR/lvds-resolution
  echo 0 > $EEEPC_VAR/lvds-state
  eeepc_notify "Display Off" $NICON
  su $EEE_USER -l -c "DISPLAY=:0 xrandr --output $LVDS_DEVICE --off"
fi
